# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from tator_openapi.configuration import Configuration


class Leaf(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'attributes': 'dict(str, object)',
        'id': 'int',
        'name': 'str',
        'parent': 'int',
        'path': 'str',
        'project': 'int'
    }

    attribute_map = {
        'attributes': 'attributes',
        'id': 'id',
        'name': 'name',
        'parent': 'parent',
        'path': 'path',
        'project': 'project'
    }

    def __init__(self, attributes=None, id=None, name=None, parent=None, path=None, project=None, local_vars_configuration=None):  # noqa: E501
        """Leaf - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._attributes = None
        self._id = None
        self._name = None
        self._parent = None
        self._path = None
        self._project = None
        self.discriminator = None

        if attributes is not None:
            self.attributes = attributes
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if parent is not None:
            self.parent = parent
        if path is not None:
            self.path = path
        if project is not None:
            self.project = project

    @property
    def attributes(self):
        """Gets the attributes of this Leaf.  # noqa: E501

        Object containing attribute values.  # noqa: E501

        :return: The attributes of this Leaf.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """Sets the attributes of this Leaf.

        Object containing attribute values.  # noqa: E501

        :param attributes: The attributes of this Leaf.  # noqa: E501
        :type attributes: dict(str, object)
        """

        self._attributes = attributes

    @property
    def id(self):
        """Gets the id of this Leaf.  # noqa: E501

        Unique integer identifying the leaf.  # noqa: E501

        :return: The id of this Leaf.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Leaf.

        Unique integer identifying the leaf.  # noqa: E501

        :param id: The id of this Leaf.  # noqa: E501
        :type id: int
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this Leaf.  # noqa: E501

        Name of the leaf.  # noqa: E501

        :return: The name of this Leaf.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Leaf.

        Name of the leaf.  # noqa: E501

        :param name: The name of this Leaf.  # noqa: E501
        :type name: str
        """

        self._name = name

    @property
    def parent(self):
        """Gets the parent of this Leaf.  # noqa: E501

        ID to use as parent if there is one.  # noqa: E501

        :return: The parent of this Leaf.  # noqa: E501
        :rtype: int
        """
        return self._parent

    @parent.setter
    def parent(self, parent):
        """Sets the parent of this Leaf.

        ID to use as parent if there is one.  # noqa: E501

        :param parent: The parent of this Leaf.  # noqa: E501
        :type parent: int
        """

        self._parent = parent

    @property
    def path(self):
        """Gets the path of this Leaf.  # noqa: E501

        Full path to leaf in hierarchy.  # noqa: E501

        :return: The path of this Leaf.  # noqa: E501
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """Sets the path of this Leaf.

        Full path to leaf in hierarchy.  # noqa: E501

        :param path: The path of this Leaf.  # noqa: E501
        :type path: str
        """

        self._path = path

    @property
    def project(self):
        """Gets the project of this Leaf.  # noqa: E501

        Unique integer identifying a project.  # noqa: E501

        :return: The project of this Leaf.  # noqa: E501
        :rtype: int
        """
        return self._project

    @project.setter
    def project(self, project):
        """Sets the project of this Leaf.

        Unique integer identifying a project.  # noqa: E501

        :param project: The project of this Leaf.  # noqa: E501
        :type project: int
        """

        self._project = project

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Leaf):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Leaf):
            return True

        return self.to_dict() != other.to_dict()
